<%
'(C) Copyright 2001 by UltraApps
'View files/license.html for Legal Information
'-------------------------------
' PriorityMaint CustomIncludes begin
%>

<!-- #INCLUDE FILE="Common.asp" -->
<!-- #INCLUDE FILE="Header.asp" -->
<!-- #INCLUDE FILE="Footer.asp" -->

<%
' PriorityMaint CustomIncludes end
'-------------------------------

'===============================
' Save Page and File Name available into variables
'-------------------------------
sFileName = "PriorityMaint.asp"
sTemplateFileName = "PriorityMaint.html"
'===============================


'===============================
' PriorityMaint PageSecurity begin
CheckSecurity(2)
' PriorityMaint PageSecurity end
'===============================

'===============================
' PriorityMaint Open Event begin
' PriorityMaint Open Event end
'===============================

'===============================
' PriorityMaint OpenAnyPage Event begin
' PriorityMaint OpenAnyPage Event end
'===============================

'===============================
'Save the name of the form and type of action into the variables
'-------------------------------
sAction = GetParam("FormAction")
sForm = GetParam("FormName")
'===============================

' PriorityMaint Show begin
'===============================
' Perform the form's action
'-------------------------------
' Initialize error variables
'-------------------------------
sPriorityMaintErr = ""

'-------------------------------
' Select the FormAction
'-------------------------------
Select Case sForm
  Case "PriorityMaint"
    PriorityMaintAction(sAction)
end select
'===============================

'===============================
' Display page
'-------------------------------
' Load HTML template for this page
'-------------------------------
LoadTemplate sAppPath & sTemplateFileName, "main"
'-------------------------------
' Load HTML template of Header and Footer
'-------------------------------
LoadTemplate sHeaderFileName, "Header"
LoadTemplate sFooterFileName, "Footer"
'-------------------------------
SetVar "FileName", sFileName


'-------------------------------
' Step through each form
'-------------------------------
Menu_Show
FooterForm_Show
PriorityMaint_Show
'-------------------------------
' Process page templates
'-------------------------------
Parse "Header", False
Parse "Footer", False
Parse "main", False
'-------------------------------
' Output the page to the browser
'-------------------------------
Response.write PrintVar("main")

' PriorityMaint Show end

'-------------------------------
' Destroy all object variables
'-------------------------------
cn.Close
Set cn = Nothing
UnloadTemplate
'===============================

'===============================
' PriorityMaint Close Event begin
' PriorityMaint Close Event end
'===============================
'===============================
' Action of the Record Form
'-------------------------------
Sub PriorityMaintAction(sAction)
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim bExecSQL: bExecSQL = true
  Dim sActionFileName : sActionFileName = ""
  Dim sWhere : sWhere = "" 
  Dim bErr : bErr = False
  Dim pPKpriority_id : pPKpriority_id = ""
  Dim fldpriority_desc : fldpriority_desc = ""
  Dim fldpriority_color : fldpriority_color = ""
  Dim fldpriority_order : fldpriority_order = ""
'-------------------------------

'-------------------------------
' PriorityMaint Action begin
'-------------------------------
  sActionFileName = "PriorityList.asp"

'-------------------------------
' Build WHERE statement
'-------------------------------
  if sAction = "update" or sAction = "delete" then
    pPKpriority_id = GetParam("PK_priority_id")
    if IsEmpty(pPKpriority_id) then exit sub
    sWhere = "priority_id=" & ToSQL(pPKpriority_id, "Number")
  end if
'-------------------------------


'-------------------------------
' Load all form fields into variables
'-------------------------------
  fldpriority_desc = GetParam("priority_desc")
  fldpriority_color = GetParam("priority_color")
  fldpriority_order = GetParam("priority_order")

'-------------------------------
' Validate fields
'-------------------------------
  if sAction = "insert" or sAction = "update" then
    if IsEmpty(fldpriority_desc) then
      sPriorityMaintErr = sPriorityMaintErr & "The value in field Priority is required.<br>"
    end if
    if not isNumeric(fldpriority_order) then
      sPriorityMaintErr = sPriorityMaintErr & "The value in field Order is incorrect.<br>"
    end if
    if not IsEmpty(fldpriority_order) and isNumeric(fldpriority_order) then
      iCount = 0
      if sAction = "insert" then
        iCount = Clng(DLookUp("priorities", "count(*)", "priority_order=" & toSQL(fldpriority_order, "Number")))
      elseif sAction = "update" then
        iCount = Clng(DLookUp("priorities", "count(*)", "priority_order=" & toSQL(fldpriority_order, "Number") & " and not(" & sWhere & ")"))
      end if
      if iCount > 0 then
        sPriorityMaintErr = sPriorityMaintErr & "The value in field Order is already in database.<br>"
      end if
    end if
'-------------------------------
' PriorityMaint Check Event begin
' PriorityMaint Check Event end
'-------------------------------
    If len(sPriorityMaintErr) > 0 then
      exit sub
    end if
  end if
'-------------------------------


'-------------------------------
' Create SQL statement
'-------------------------------
  select case sAction
    case "insert"
'-------------------------------
' PriorityMaint Insert Event begin
' PriorityMaint Insert Event end
'-------------------------------
      sSQL = "insert into priorities (" & _
          "[priority_desc]," & _
          "[priority_color]," & _
          "[priority_order])" & _
          " values (" & _
          ToSQL(fldpriority_desc, "Text") & "," & _
          ToSQL(fldpriority_color, "Text") & "," & _
          ToSQL(fldpriority_order, "Number") & _
          ")"
    case "update"
'-------------------------------
' PriorityMaint Update Event begin
' PriorityMaint Update Event end
'-------------------------------
      sSQL = "update priorities set " & _
        "[priority_desc]=" & ToSQL(fldpriority_desc, "Text") & _
        ",[priority_color]=" & ToSQL(fldpriority_color, "Text") & _
        ",[priority_order]=" & ToSQL(fldpriority_order, "Number")
      sSQL = sSQL & " where " & sWhere
    case "delete"
'-------------------------------
' PriorityMaint Delete Event begin
' PriorityMaint Delete Event end
'-------------------------------
      sSQL = "delete from priorities where " & sWhere
  end select
'-------------------------------
'-------------------------------
' PriorityMaint BeforeExecute Event begin
' PriorityMaint BeforeExecute Event end
'-------------------------------

'-------------------------------
' Execute SQL statement
'-------------------------------
if len(sPriorityMaintErr) > 0 then Exit Sub
  on error resume next
  if bExecSQL then 
    cn.execute sSQL
  end if
  sPriorityMaintErr = ProcessError
  on error goto 0
  if len(sPriorityMaintErr) > 0 then Exit Sub
  cn.Close
  Set cn = Nothing
  response.redirect sActionFileName
'-------------------------------
' PriorityMaint Action end
'-------------------------------
end sub
'===============================

'===============================
' Display Record Form
'-------------------------------
Sub PriorityMaint_Show()
'-------------------------------
' PriorityMaint Show begin
'-------------------------------
  Dim sWhere : sWhere = ""
  Dim sFormTitle: sFormTitle = "Add/Edit Priority"
  Dim bPK : bPK = True

'-------------------------------
' Load primary key and form parameters
'-------------------------------
  if sPriorityMaintErr = "" then
    fldpriority_id = GetParam("priority_id")
    ppriority_id = GetParam("priority_id")
    SetVar "PriorityMaintError", ""
  else
    fldpriority_id = GetParam("priority_id")
    fldpriority_desc = GetParam("priority_desc")
    fldpriority_color = GetParam("priority_color")
    fldpriority_order = GetParam("priority_order")
    ppriority_id = GetParam("PK_priority_id")
    SetVar "sPriorityMaintErr", sPriorityMaintErr
    SetVar "FormTitle", sFormTitle
    Parse "PriorityMaintError", False
  end if
'-------------------------------

'-------------------------------
' Load all form fields

'-------------------------------

'-------------------------------
' Build WHERE statement

  if IsEmpty(ppriority_id) then bPK = False
  
  sWhere = sWhere & "priority_id=" & ToSQL(ppriority_id, "Number")
  SetVar "PK_priority_id", ppriority_id
'-------------------------------
'-------------------------------
' PriorityMaint Open Event begin
' PriorityMaint Open Event end
'-------------------------------

  SetVar "FormTitle", sFormTitle

'-------------------------------
' Build SQL statement and open recordset
'-------------------------------
  sSQL = "select * from priorities where " & sWhere
  openrs rs, sSQL
  bIsUpdateMode = (bPK and not(sAction = "insert" and sForm = "PriorityMaint") and not rs.eof)
'-------------------------------

'-------------------------------
' Load all fields into variables from recordset or input parameters
'-------------------------------
  if bIsUpdateMode then
    fldpriority_id = GetValue(rs, "priority_id")

'-------------------------------
' Load data from recordset when form displayed first time
'-------------------------------
    if sPriorityMaintErr = "" then
      fldpriority_desc = GetValue(rs, "priority_desc")
      fldpriority_color = GetValue(rs, "priority_color")
      fldpriority_order = GetValue(rs, "priority_order")
    end if
    SetVar "PriorityMaintInsert", ""
    Parse "PriorityMaintEdit", False
'-------------------------------
' PriorityMaint ShowEdit Event begin
' PriorityMaint ShowEdit Event end
'-------------------------------
  else
    if sPriorityMaintErr = "" then
      fldpriority_id = ToHTML(GetParam("priority_id"))
    end if
    SetVar "PriorityMaintEdit", ""
    Parse "PriorityMaintInsert", False
'-------------------------------
' PriorityMaint ShowInsert Event begin
' PriorityMaint ShowInsert Event end
'-------------------------------
  end if
  SetVar "PriorityMaintCancel", ""
'-------------------------------
' PriorityMaint Show Event begin
' PriorityMaint Show Event end
'-------------------------------

'-------------------------------
' Show form field
'-------------------------------
      SetVar "priority_id", ToHTML(fldpriority_id)
      SetVar "priority_desc", ToHTML(fldpriority_desc)
      SetVar "priority_color", ToHTML(fldpriority_color)
      SetVar "priority_order", ToHTML(fldpriority_order)
  Parse "FormPriorityMaint", False

'-------------------------------
' PriorityMaint Close Event begin
' PriorityMaint Close Event end
'-------------------------------

Set rs = Nothing

'-------------------------------
' PriorityMaint Show end
'-------------------------------
End Sub
'===============================
%>